ActiveMQSession (ActiveMQ 1.1 API)
Keywords: org.codehaus.activemq.ActiveMQSession class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.codehaus.activemq
Class ActiveMQSession

    java.lang.Object
      org.codehaus.activemq.ActiveMQSession

All Implemented Interfaces:
  ActiveMQMessageDispatcher, MessageAcknowledge, QueueSession, Runnable, Session, StatsCapable, TopicSession

Direct Known Subclasses:
  ActiveMQXASession

public class ActiveMQSession
extends Object
implements Session, QueueSession, TopicSession, ActiveMQMessageDispatcher, MessageAcknowledge, StatsCapable

A `Session` object is a single-threaded context for producing and consuming messages. Although it may allocate provider resources outside the Java virtual machine (JVM), it is considered a lightweight JMS object.

A session serves several purposes:

- It is a factory for its message producers and consumers.
- It supplies provider-optimized message factories.
- It is a factory for `TemporaryTopics` and `TemporaryQueues`.
- It provides a way to create `Queue` or `Topic` objects for those clients that need to dynamically manipulate provider-specific destination names.
- It supports a single series of transactions that combine work spanning its producers and consumers into atomic units.
- It defines a serial order for the messages it consumes and the messages it produces.
- It retains messages it consumes until they have been acknowledged.
- It serializes execution of message listeners registered with its message consumers.
- It is a factory for `QueueBrowsers`.

A session can create and service multiple message producers and consumers.

One typical use is to have a thread block on a synchronous `MessageConsumer` until a message arrives. The thread may then use one or more of the `Session`'s`MessageProducer`s.

If a client desires to have one thread produce messages while others consume them, the client should use a separate session for its producing thread.

Once a connection has been started, any session with one or more registered message listeners is dedicated to the thread of control that delivers messages to it. It is erroneous for client code to use this session or any of its constituent objects from another thread of control. The only exception to this rule is the use of the session or connection `close` method.

It should be easy for most clients to partition their work naturally into sessions. This model allows clients to start simply and incrementally add message processing complexity as their need for concurrency grows.

The `close` method is the only session method that can be called while some other session method is being executed in another thread.

A session may be specified as transacted. Each transacted session supports a single series of transactions. Each transaction groups a set of message sends and a set of message receives into an atomic unit of work. In effect, transactions organize a session's input message stream and output message stream into series of atomic units. When a transaction commits, its atomic unit of input is acknowledged and its associated atomic unit of output is sent. If a transaction rollback is done, the transaction's sent messages are destroyed and the session's input is automatically recovered.

The content of a transaction's input and output units is simply those messages that have been produced and consumed within the session's current transaction.

A transaction is completed using either its session's `commit` method or its session's `rollback` method. The completion of a session's current transaction automatically begins the next. The result is that a transacted session always has a current transaction within which its work is done.

The Java Transaction Service (JTS) or some other transaction monitor may be used to combine a session's transaction with transactions on other resources (databases, other JMS sessions, etc.). Since Java distributed transactions are controlled via the Java Transaction API (JTA), use of the session's `commit` and `rollback` methods in this context is prohibited.

The JMS API does not require support for JTA; however, it does define how a provider supplies this support.

Although it is also possible for a JMS client to handle distributed transactions directly, it is unlikely that many JMS clients will do this. Support for JTA in the JMS API is targeted at systems vendors who will be integrating the JMS API into their application server products.

Version:
  $Revision: 1.54 $
See Also:
  `Session`, `QueueSession`, `TopicSession`, `XASession`

Field Summary
`protected SynchronizedBoolean` | `closed`
`protected ActiveMQConnection` | `connection`
`protected static int` | `CONSUMER_DISPATCH_ASYNC`
`protected static int` | `CONSUMER_DISPATCH_SYNC`
`protected static int` | `CONSUMER_DISPATCH_UNSET`
`protected CopyOnWriteArrayList` | `consumers`
`protected String` | `currentTransactionId`
`protected IdGenerator` | `packetIdGenerator`
`protected CopyOnWriteArrayList` | `producers`

Fields inherited from interface javax.jms.Session
`AUTO_ACKNOWLEDGE, CLIENT_ACKNOWLEDGE, DUPS_OK_ACKNOWLEDGE, SESSION_TRANSACTED`

Constructor Summary
`protected` | `ActiveMQSession(ActiveMQConnection theConnection, int theAcknowledgeMode)` Construct the Session

Method Summary
`void` | `acknowledge()` Acknowledges all consumed messages of the session of this consumed message.
`protected void` | `addConsumer(ActiveMQMessageConsumer consumer)`
`protected void` | `addProducer(ActiveMQMessageProducer producer)`
`protected void` | `checkClosed()`
`protected void` | `clearMessagesInProgress()`
`void` | `close()` Closes the session.
`void` | `commit()` Commits all messages done in this transaction and releases any locks currently held.
`QueueBrowser` | `createBrowser(Queue queue)` Creates a `QueueBrowser` object to peek at the messages on the specified queue.
`QueueBrowser` | `createBrowser(Queue queue, String messageSelector)` Creates a `QueueBrowser` object to peek at the messages on the specified queue using a message selector.
`BytesMessage` | `createBytesMessage()` Creates a `BytesMessage` object.
`MessageConsumer` | `createConsumer(Destination destination)` Creates a `MessageConsumer` for the specified destination.
`MessageConsumer` | `createConsumer(Destination destination, String messageSelector)` Creates a `MessageConsumer` for the specified destination, using a message selector.
`MessageConsumer` | `createConsumer(Destination destination, String messageSelector, boolean NoLocal)` Creates `MessageConsumer` for the specified destination, using a message selector.
`protected ConsumerInfo` | `createConsumerInfo(ActiveMQMessageConsumer consumer)`
`TopicSubscriber` | `createDurableSubscriber(Topic topic, String name)` Creates a durable subscriber to the specified topic.
`TopicSubscriber` | `createDurableSubscriber(Topic topic, String name, String messageSelector, boolean noLocal)` Creates a durable subscriber to the specified topic, using a message selector and specifying whether messages published by its own connection should be delivered to it.
`MapMessage` | `createMapMessage()` Creates a `MapMessage` object.
`Message` | `createMessage()` Creates a `Message` object.
`ObjectMessage` | `createObjectMessage()` Creates an `ObjectMessage` object.
`ObjectMessage` | `createObjectMessage(Serializable object)` Creates an initialized `ObjectMessage` object.
`MessageProducer` | `createProducer(Destination destination)` Creates a `MessageProducer` to send messages to the specified destination.
`protected ProducerInfo` | `createProducerInfo(ActiveMQMessageProducer producer)`
`TopicPublisher` | `createPublisher(Topic topic)` Creates a publisher for the specified topic.
`Queue` | `createQueue(String queueName)` Creates a queue identity given a `Queue` name.
`QueueReceiver` | `createReceiver(Queue queue)` Creates a `QueueReceiver` object to receive messages from the specified queue.
`QueueReceiver` | `createReceiver(Queue queue, String messageSelector)` Creates a `QueueReceiver` object to receive messages from the specified queue using a message selector.
`QueueSender` | `createSender(Queue queue)` Creates a `QueueSender` object to send messages to the specified queue.
`StreamMessage` | `createStreamMessage()` Creates a `StreamMessage` object.
`TopicSubscriber` | `createSubscriber(Topic topic)` Creates a nondurable subscriber to the specified topic.
`TopicSubscriber` | `createSubscriber(Topic topic, String messageSelector, boolean noLocal)` Creates a nondurable subscriber to the specified topic, using a message selector or specifying whether messages published by its own connection should be delivered to it.
`TemporaryQueue` | `createTemporaryQueue()` Creates a `TemporaryQueue` object.
`TemporaryTopic` | `createTemporaryTopic()` Creates a `TemporaryTopic` object.
`TextMessage` | `createTextMessage()` Creates a `TextMessage` object.
`TextMessage` | `createTextMessage(String text)` Creates an initialized `TextMessage` object.
`Topic` | `createTopic(String topicName)` Creates a topic identity given a `Topic` name.
`void` | `dispatch(ActiveMQMessage message)` Dispatch an ActiveMQMessage
`protected void` | `doAcknowledge(boolean isClosing)`
`protected void` | `doClose()`
`protected void` | `doStartTransaction()` Send TransactionInfo to indicate transaction has started
`int` | `getAcknowledgeMode()` Returns the acknowledgement mode of the session.
`LocalTransactionEventListener` | `getLocalTransactionEventListener()`
`MessageListener` | `getMessageListener()` Returns the session's distinguished message listener (optional).
`protected String` | `getNextTransactionId()`
`protected String` | `getSessionId()`
`JMSSessionStatsImpl` | `getSessionStats()`
`protected long` | `getStartTime()`
`Stats` | `getStats()`
`boolean` | `getTransacted()` Indicates whether the session is in transacted mode.
`protected boolean` | `isClientAcknowledge()`
`boolean` | `isTarget(ActiveMQMessage message)` Tests to see if the Message Dispatcher is a target for this message
`protected boolean` | `isTransacted()`
`protected boolean` | `isXaTransacted()`
`protected void` | `messageDelivered(boolean sendAcknowledge, ActiveMQMessage message, boolean messageConsumed)`
`void` | `recover()` Stops message delivery in this session, and restarts message delivery with the oldest unacknowledged message.
`protected void` | `redeliverUnacknowledgedMessages()`
`protected void` | `redeliverUnacknowledgedMessages(boolean onlyDeliverTransientConsumed)`
`protected void` | `removeConsumer(ActiveMQMessageConsumer consumer)`
`protected void` | `removeProducer(ActiveMQMessageProducer producer)`
`void` | `rollback()` Rolls back any messages done in this transaction and releases any locks currently held.
`void` | `run()` Optional operation, intended to be used only by Application Servers, not by ordinary JMS clients.
`protected void` | `send(ActiveMQMessageProducer producer, Destination destination, Message message, int deliveryMode, int priority, long timeToLive, boolean reuseMessageId)` send the message for dispatch by the broker
`void` | `setLocalTransactionEventListener(LocalTransactionEventListener localTransactionEventListener)` Used by the resource adapter to listen to transaction events.
`void` | `setMessageListener(MessageListener listener)` Sets the session's distinguished message listener (optional).
`protected void` | `setSessionConsumerDispatchState(int value)`
`protected void` | `setSessionId(String sessionId)`
`protected void` | `setStartTime(long startTime)`
`protected void` | `start()` Start this Session
`protected void` | `stop()` Stop this Session
`void` | `unsubscribe(String name)` Unsubscribes a durable subscription that has been created by a client.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CONSUMER_DISPATCH_UNSET

    protected static final int CONSUMER_DISPATCH_UNSET

See Also:
  Constant Field Values

### CONSUMER_DISPATCH_ASYNC

    protected static final int CONSUMER_DISPATCH_ASYNC

See Also:
  Constant Field Values

### CONSUMER_DISPATCH_SYNC

    protected static final int CONSUMER_DISPATCH_SYNC

See Also:
  Constant Field Values

### connection

    protected ActiveMQConnection connection

### consumers

    protected CopyOnWriteArrayList consumers

### producers

    protected CopyOnWriteArrayList producers

### packetIdGenerator

    protected IdGenerator packetIdGenerator

### closed

    protected SynchronizedBoolean closed

### currentTransactionId

    protected String currentTransactionId

Constructor Detail

### ActiveMQSession

    protected ActiveMQSession(ActiveMQConnection theConnection,
                              int theAcknowledgeMode)
                       throws JMSException

  Construct the Session

Parameters:
  `theConnection` -
  `theAcknowledgeMode` - n.b if transacted - the acknowledgeMode == Session.SESSION_TRANSACTED
Throws:
  `JMSException` - on internal error

Method Detail

### getStats

    public Stats getStats()

  Specified by:
    `getStats` in interface `StatsCapable`
  Returns:
    the Stats for this object

### getSessionStats

    public JMSSessionStatsImpl getSessionStats()

### createBytesMessage

    public BytesMessage createBytesMessage()
                                    throws JMSException

  Creates a `BytesMessage` object. A `BytesMessage` object is used to send a message containing a stream of uninterpreted bytes.

  Specified by:
    `createBytesMessage` in interface `Session`
  Returns:
    the an ActiveMQBytesMessage
  Throws:
    `JMSException` - if the JMS provider fails to create this message due to some internal error.

### createMapMessage

    public MapMessage createMapMessage()
                                throws JMSException

  Creates a `MapMessage` object. A `MapMessage` object is used to send a self-defining set of name-value pairs, where names are `String` objects and values are primitive values in the Java programming language.

  Specified by:
    `createMapMessage` in interface `Session`
  Returns:
    an ActiveMQMapMessage
  Throws:
    `JMSException` - if the JMS provider fails to create this message due to some internal error.

### createMessage

    public Message createMessage()
                          throws JMSException

  Creates a `Message` object. The `Message` interface is the root interface of all JMS messages. A `Message` object holds all the standard message header information. It can be sent when a message containing only header information is sufficient.

  Specified by:
    `createMessage` in interface `Session`
  Returns:
    an ActiveMQMessage
  Throws:
    `JMSException` - if the JMS provider fails to create this message due to some internal error.

### createObjectMessage

    public ObjectMessage createObjectMessage()
                                      throws JMSException

  Creates an `ObjectMessage` object. An `ObjectMessage` object is used to send a message that contains a serializable Java object.

  Specified by:
    `createObjectMessage` in interface `Session`
  Returns:
    an ActiveMQObjectMessage
  Throws:
    `JMSException` - if the JMS provider fails to create this message due to some internal error.

### createObjectMessage

    public ObjectMessage createObjectMessage(Serializable object)
                                      throws JMSException

  Creates an initialized `ObjectMessage` object. An `ObjectMessage` object is used to send a message that contains a serializable Java object.

  Specified by:
    `createObjectMessage` in interface `Session`
  Parameters:
    `object` - the object to use to initialize this message
  Returns:
    an ActiveMQObjectMessage
  Throws:
    `JMSException` - if the JMS provider fails to create this message due to some internal error.

### createStreamMessage

    public StreamMessage createStreamMessage()
                                      throws JMSException

  Creates a `StreamMessage` object. A `StreamMessage` object is used to send a self-defining stream of primitive values in the Java programming language.

  Specified by:
    `createStreamMessage` in interface `Session`
  Returns:
    an ActiveMQStreamMessage
  Throws:
    `JMSException` - if the JMS provider fails to create this message due to some internal error.

### createTextMessage

    public TextMessage createTextMessage()
                                  throws JMSException

  Creates a `TextMessage` object. A `TextMessage` object is used to send a message containing a `String` object.

  Specified by:
    `createTextMessage` in interface `Session`
  Returns:
    an ActiveMQTextMessage
  Throws:
    `JMSException` - if the JMS provider fails to create this message due to some internal error.

### createTextMessage

    public TextMessage createTextMessage(String text)
                                  throws JMSException

  Creates an initialized `TextMessage` object. A `TextMessage` object is used to send a message containing a `String`.

  Specified by:
    `createTextMessage` in interface `Session`
  Parameters:
    `text` - the string used to initialize this message
  Returns:
    an ActiveMQTextMessage
  Throws:
    `JMSException` - if the JMS provider fails to create this message due to some internal error.

### getTransacted

    public boolean getTransacted()
                          throws JMSException

  Indicates whether the session is in transacted mode.

  Specified by:
    `getTransacted` in interface `Session`
  Returns:
    true if the session is in transacted mode
  Throws:
    `JMSException` - if there is some internal error.

### getAcknowledgeMode

    public int getAcknowledgeMode()
                           throws JMSException

  Returns the acknowledgement mode of the session. The acknowledgement mode is set at the time that the session is created. If the session is transacted, the acknowledgement mode is ignored.

  Specified by:
    `getAcknowledgeMode` in interface `Session`
  Returns:
    If the session is not transacted, returns the current acknowledgement mode for the session. If the session is transacted, returns SESSION_TRANSACTED.
  Throws:
    `JMSException`
  Since:
    1.1 exception JMSException if there is some internal error.
  See Also:
    `Connection.createSession(boolean,int)`

### commit

    public void commit()
                throws JMSException

  Commits all messages done in this transaction and releases any locks currently held.

  Specified by:
    `commit` in interface `Session`
  Throws:
    `JMSException` - if the JMS provider fails to commit the transaction due to some internal error.
    `TransactionRolledBackException` - if the transaction is rolled back due to some internal error during commit.
    `IllegalStateException` - if the method is not called by a transacted session.

### rollback

    public void rollback()
                  throws JMSException

  Rolls back any messages done in this transaction and releases any locks currently held.

  Specified by:
    `rollback` in interface `Session`
  Throws:
    `JMSException` - if the JMS provider fails to roll back the transaction due to some internal error.
    `IllegalStateException` - if the method is not called by a transacted session.

### close

    public void close()
               throws JMSException

  Closes the session.

  Since a provider may allocate some resources on behalf of a session outside the JVM, clients should close the resources when they are not needed. Relying on garbage collection to eventually reclaim these resources may not be timely enough.

  There is no need to close the producers and consumers of a closed session.

  This call will block until a `receive` call or message listener in progress has completed. A blocked message consumer `receive` call returns `null` when this session is closed.

  Closing a transacted session must roll back the transaction in progress.

  This method is the only `Session` method that can be called concurrently.

  Invoking any other `Session` method on a closed session must throw a `JMSException.IllegalStateException`. Closing a closed session must not throw an exception.

  Specified by:
    `close` in interface `Session`
  Throws:
    `JMSException` - if the JMS provider fails to close the session due to some internal error.

### doClose

    protected void doClose()
                    throws JMSException

  Throws:
    `JMSException`

### checkClosed

    protected void checkClosed()
                        throws IllegalStateException

  Throws:
    `IllegalStateException` - if the Session is closed

### recover

    public void recover()
                 throws JMSException

  Stops message delivery in this session, and restarts message delivery with the oldest unacknowledged message.

  All consumers deliver messages in a serial order. Acknowledging a received message automatically acknowledges all messages that have been delivered to the client.

  Restarting a session causes it to take the following actions:

  - Stop message delivery
  - Mark all messages that might have been delivered but not acknowledged as "redelivered"
  - Restart the delivery sequence including all unacknowledged messages that had been previously delivered. Redelivered messages do not have to be delivered in exactly their original delivery order.

  Specified by:
    `recover` in interface `Session`
  Throws:
    `JMSException` - if the JMS provider fails to stop and restart message delivery due to some internal error.
    `IllegalStateException` - if the method is called by a transacted session.

### getMessageListener

    public MessageListener getMessageListener()
                                       throws JMSException

  Returns the session's distinguished message listener (optional).

  Specified by:
    `getMessageListener` in interface `Session`
  Returns:
    the message listener associated with this session
  Throws:
    `JMSException` - if the JMS provider fails to get the message listener due to an internal error.
  See Also:
    `Session.setMessageListener(javax.jms.MessageListener)`, `ServerSessionPool`, `ServerSession`

### setMessageListener

    public void setMessageListener(MessageListener listener)
                            throws JMSException

  Sets the session's distinguished message listener (optional).

  When the distinguished message listener is set, no other form of message receipt in the session can be used; however, all forms of sending messages are still supported.

  This is an expert facility not used by regular JMS clients.

  Specified by:
    `setMessageListener` in interface `Session`
  Parameters:
    `listener` - the message listener to associate with this session
  Throws:
    `JMSException` - if the JMS provider fails to set the message listener due to an internal error.
  See Also:
    `Session.getMessageListener()`, `ServerSessionPool`, `ServerSession`

### run

    public void run()

  Optional operation, intended to be used only by Application Servers, not by ordinary JMS clients.

  Specified by:
    `run` in interface `Session`
  See Also:
    `ServerSession`

### createProducer

    public MessageProducer createProducer(Destination destination)
                                   throws JMSException

  Creates a `MessageProducer` to send messages to the specified destination.

  A client uses a `MessageProducer` object to send messages to a destination. Since `Queue` and `Topic` both inherit from `Destination`, they can be used in the destination parameter to create a `MessageProducer` object.

  Specified by:
    `createProducer` in interface `Session`
  Parameters:
    `destination` - the `Destination` to send to, or null if this is a producer which does not have a specified destination.
  Returns:
    the MessageProducer
  Throws:
    `JMSException` - if the session fails to create a MessageProducer due to some internal error.
    `InvalidDestinationException` - if an invalid destination is specified.
  Since:
    1.1

### createConsumer

    public MessageConsumer createConsumer(Destination destination)
                                   throws JMSException

  Creates a `MessageConsumer` for the specified destination. Since `Queue` and `Topic` both inherit from `Destination`, they can be used in the destination parameter to create a `MessageConsumer`.

  Specified by:
    `createConsumer` in interface `Session`
  Parameters:
    `destination` - the `Destination` to access.
  Returns:
    the MessageConsumer
  Throws:
    `JMSException` - if the session fails to create a consumer due to some internal error.
    `InvalidDestinationException` - if an invalid destination is specified.
  Since:
    1.1

### createConsumer

    public MessageConsumer createConsumer(Destination destination,
                                          String messageSelector)
                                   throws JMSException

  Creates a `MessageConsumer` for the specified destination, using a message selector. Since `Queue` and `Topic` both inherit from `Destination`, they can be used in the destination parameter to create a `MessageConsumer`.

  A client uses a `MessageConsumer` object to receive messages that have been sent to a destination.

  Specified by:
    `createConsumer` in interface `Session`
  Parameters:
    `destination` - the `Destination` to access
    `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
  Returns:
    the MessageConsumer
  Throws:
    `JMSException` - if the session fails to create a MessageConsumer due to some internal error.
    `InvalidDestinationException` - if an invalid destination is specified.
    `InvalidSelectorException` - if the message selector is invalid.
  Since:
    1.1

### createConsumer

    public MessageConsumer createConsumer(Destination destination,
                                          String messageSelector,
                                          boolean NoLocal)
                                   throws JMSException

  Creates `MessageConsumer` for the specified destination, using a message selector. This method can specify whether messages published by its own connection should be delivered to it, if the destination is a topic.

  Since `Queue` and `Topic` both inherit from `Destination`, they can be used in the destination parameter to create a `MessageConsumer`.

  A client uses a `MessageConsumer` object to receive messages that have been published to a destination.

  In some cases, a connection may both publish and subscribe to a topic. The consumer `NoLocal` attribute allows a consumer to inhibit the delivery of messages published by its own connection. The default value for this attribute is False. The `noLocal` value must be supported by destinations that are topics.

  Specified by:
    `createConsumer` in interface `Session`
  Parameters:
    `destination` - the `Destination` to access
    `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
    `NoLocal` - - if true, and the destination is a topic, inhibits the delivery of messages published by its own connection. The behavior for `NoLocal` is not specified if the destination is a queue.
  Returns:
    the MessageConsumer
  Throws:
    `JMSException` - if the session fails to create a MessageConsumer due to some internal error.
    `InvalidDestinationException` - if an invalid destination is specified.
    `InvalidSelectorException` - if the message selector is invalid.
  Since:
    1.1

### createQueue

    public Queue createQueue(String queueName)
                      throws JMSException

  Creates a queue identity given a `Queue` name.

  This facility is provided for the rare cases where clients need to dynamically manipulate queue identity. It allows the creation of a queue identity with a provider-specific name. Clients that depend on this ability are not portable.

  Note that this method is not for creating the physical queue. The physical creation of queues is an administrative task and is not to be initiated by the JMS API. The one exception is the creation of temporary queues, which is accomplished with the `createTemporaryQueue` method.

  Specified by:
    `createQueue` in interface `Session`
  Parameters:
    `queueName` - the name of this `Queue`
  Returns:
    a `Queue` with the given name
  Throws:
    `JMSException` - if the session fails to create a queue due to some internal error.
  Since:
    1.1

### createTopic

    public Topic createTopic(String topicName)
                      throws JMSException

  Creates a topic identity given a `Topic` name.

  This facility is provided for the rare cases where clients need to dynamically manipulate topic identity. This allows the creation of a topic identity with a provider-specific name. Clients that depend on this ability are not portable.

  Note that this method is not for creating the physical topic. The physical creation of topics is an administrative task and is not to be initiated by the JMS API. The one exception is the creation of temporary topics, which is accomplished with the `createTemporaryTopic` method.

  Specified by:
    `createTopic` in interface `Session`
  Parameters:
    `topicName` - the name of this `Topic`
  Returns:
    a `Topic` with the given name
  Throws:
    `JMSException` - if the session fails to create a topic due to some internal error.
  Since:
    1.1

### createDurableSubscriber

    public TopicSubscriber createDurableSubscriber(Topic topic,
                                                   String name)
                                            throws JMSException

  Creates a durable subscriber to the specified topic.

  If a client needs to receive all the messages published on a topic, including the ones published while the subscriber is inactive, it uses a durable `TopicSubscriber`. The JMS provider retains a record of this durable subscription and insures that all messages from the topic's publishers are retained until they are acknowledged by this durable subscriber or they have expired.

  Sessions with durable subscribers must always provide the same client identifier. In addition, each client must specify a name that uniquely identifies (within client identifier) each durable subscription it creates. Only one session at a time can have a `TopicSubscriber` for a particular durable subscription.

  A client can change an existing durable subscription by creating a durable `TopicSubscriber` with the same name and a new topic and/or message selector. Changing a durable subscriber is equivalent to unsubscribing (deleting) the old one and creating a new one.

  In some cases, a connection may both publish and subscribe to a topic. The subscriber `NoLocal` attribute allows a subscriber to inhibit the delivery of messages published by its own connection. The default value for this attribute is false.

  Specified by:
    `createDurableSubscriber` in interface `Session`
  Parameters:
    `topic` - the non-temporary `Topic` to subscribe to
    `name` - the name used to identify this subscription
  Returns:
    the TopicSubscriber
  Throws:
    `JMSException` - if the session fails to create a subscriber due to some internal error.
    `InvalidDestinationException` - if an invalid topic is specified.
  Since:
    1.1

### createDurableSubscriber

    public TopicSubscriber createDurableSubscriber(Topic topic,
                                                   String name,
                                                   String messageSelector,
                                                   boolean noLocal)
                                            throws JMSException

  Creates a durable subscriber to the specified topic, using a message selector and specifying whether messages published by its own connection should be delivered to it.

  If a client needs to receive all the messages published on a topic, including the ones published while the subscriber is inactive, it uses a durable `TopicSubscriber`. The JMS provider retains a record of this durable subscription and insures that all messages from the topic's publishers are retained until they are acknowledged by this durable subscriber or they have expired.

  Sessions with durable subscribers must always provide the same client identifier. In addition, each client must specify a name which uniquely identifies (within client identifier) each durable subscription it creates. Only one session at a time can have a `TopicSubscriber` for a particular durable subscription. An inactive durable subscriber is one that exists but does not currently have a message consumer associated with it.

  A client can change an existing durable subscription by creating a durable `TopicSubscriber` with the same name and a new topic and/or message selector. Changing a durable subscriber is equivalent to unsubscribing (deleting) the old one and creating a new one.

  Specified by:
    `createDurableSubscriber` in interface `Session`
  Parameters:
    `topic` - the non-temporary `Topic` to subscribe to
    `name` - the name used to identify this subscription
    `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
    `noLocal` - if set, inhibits the delivery of messages published by its own connection
  Returns:
    the Queue Browser
  Throws:
    `JMSException` - if the session fails to create a subscriber due to some internal error.
    `InvalidDestinationException` - if an invalid topic is specified.
    `InvalidSelectorException` - if the message selector is invalid.
  Since:
    1.1

### createBrowser

    public QueueBrowser createBrowser(Queue queue)
                               throws JMSException

  Creates a `QueueBrowser` object to peek at the messages on the specified queue.

  Specified by:
    `createBrowser` in interface `Session`
  Parameters:
    `queue` - the `queue` to access
  Returns:
    the Queue Browser
  Throws:
    `JMSException` - if the session fails to create a browser due to some internal error.
    `InvalidDestinationException` - if an invalid destination is specified
  Since:
    1.1

### createBrowser

    public QueueBrowser createBrowser(Queue queue,
                                      String messageSelector)
                               throws JMSException

  Creates a `QueueBrowser` object to peek at the messages on the specified queue using a message selector.

  Specified by:
    `createBrowser` in interface `Session`
  Parameters:
    `queue` - the `queue` to access
    `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
  Returns:
    the Queue Browser
  Throws:
    `JMSException` - if the session fails to create a browser due to some internal error.
    `InvalidDestinationException` - if an invalid destination is specified
    `InvalidSelectorException` - if the message selector is invalid.
  Since:
    1.1

### createTemporaryQueue

    public TemporaryQueue createTemporaryQueue()
                                        throws JMSException

  Creates a `TemporaryQueue` object. Its lifetime will be that of the `Connection` unless it is deleted earlier.

  Specified by:
    `createTemporaryQueue` in interface `Session`
  Returns:
    a temporary queue identity
  Throws:
    `JMSException` - if the session fails to create a temporary queue due to some internal error.
  Since:
    1.1

### createTemporaryTopic

    public TemporaryTopic createTemporaryTopic()
                                        throws JMSException

  Creates a `TemporaryTopic` object. Its lifetime will be that of the `Connection` unless it is deleted earlier.

  Specified by:
    `createTemporaryTopic` in interface `Session`
  Returns:
    a temporary topic identity
  Throws:
    `JMSException` - if the session fails to create a temporary topic due to some internal error.
  Since:
    1.1

### createReceiver

    public QueueReceiver createReceiver(Queue queue)
                                 throws JMSException

  Creates a `QueueReceiver` object to receive messages from the specified queue.

  Specified by:
    `createReceiver` in interface `QueueSession`
  Parameters:
    `queue` - the `Queue` to access
  Returns:
    @throws JMSException if the session fails to create a receiver due to some internal error.
  Throws:
    `JMSException`
    `InvalidDestinationException` - if an invalid queue is specified.

### createReceiver

    public QueueReceiver createReceiver(Queue queue,
                                        String messageSelector)
                                 throws JMSException

  Creates a `QueueReceiver` object to receive messages from the specified queue using a message selector.

  Specified by:
    `createReceiver` in interface `QueueSession`
  Parameters:
    `queue` - the `Queue` to access
    `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
  Returns:
    QueueReceiver
  Throws:
    `JMSException` - if the session fails to create a receiver due to some internal error.
    `InvalidDestinationException` - if an invalid queue is specified.
    `InvalidSelectorException` - if the message selector is invalid.

### createSender

    public QueueSender createSender(Queue queue)
                             throws JMSException

  Creates a `QueueSender` object to send messages to the specified queue.

  Specified by:
    `createSender` in interface `QueueSession`
  Parameters:
    `queue` - the `Queue` to access, or null if this is an unidentified producer
  Returns:
    QueueSender
  Throws:
    `JMSException` - if the session fails to create a sender due to some internal error.
    `InvalidDestinationException` - if an invalid queue is specified.

### createSubscriber

    public TopicSubscriber createSubscriber(Topic topic)
                                     throws JMSException

  Creates a nondurable subscriber to the specified topic.

  A client uses a `TopicSubscriber` object to receive messages that have been published to a topic.

  Regular `TopicSubscriber` objects are not durable. They receive only messages that are published while they are active.

  In some cases, a connection may both publish and subscribe to a topic. The subscriber `NoLocal` attribute allows a subscriber to inhibit the delivery of messages published by its own connection. The default value for this attribute is false.

  Specified by:
    `createSubscriber` in interface `TopicSession`
  Parameters:
    `topic` - the `Topic` to subscribe to
  Returns:
    TopicSubscriber
  Throws:
    `JMSException` - if the session fails to create a subscriber due to some internal error.
    `InvalidDestinationException` - if an invalid topic is specified.

### createSubscriber

    public TopicSubscriber createSubscriber(Topic topic,
                                            String messageSelector,
                                            boolean noLocal)
                                     throws JMSException

  Creates a nondurable subscriber to the specified topic, using a message selector or specifying whether messages published by its own connection should be delivered to it.

  A client uses a `TopicSubscriber` object to receive messages that have been published to a topic.

  Regular `TopicSubscriber` objects are not durable. They receive only messages that are published while they are active.

  Messages filtered out by a subscriber's message selector will never be delivered to the subscriber. From the subscriber's perspective, they do not exist.

  In some cases, a connection may both publish and subscribe to a topic. The subscriber `NoLocal` attribute allows a subscriber to inhibit the delivery of messages published by its own connection. The default value for this attribute is false.

  Specified by:
    `createSubscriber` in interface `TopicSession`
  Parameters:
    `topic` - the `Topic` to subscribe to
    `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
    `noLocal` - if set, inhibits the delivery of messages published by its own connection
  Returns:
    TopicSubscriber
  Throws:
    `JMSException` - if the session fails to create a subscriber due to some internal error.
    `InvalidDestinationException` - if an invalid topic is specified.
    `InvalidSelectorException` - if the message selector is invalid.

### createPublisher

    public TopicPublisher createPublisher(Topic topic)
                                   throws JMSException

  Creates a publisher for the specified topic.

  A client uses a `TopicPublisher` object to publish messages on a topic. Each time a client creates a `TopicPublisher` on a topic, it defines a new sequence of messages that have no ordering relationship with the messages it has previously sent.

  Specified by:
    `createPublisher` in interface `TopicSession`
  Parameters:
    `topic` - the `Topic` to publish to, or null if this is an unidentified producer
  Returns:
    TopicPublisher
  Throws:
    `JMSException` - if the session fails to create a publisher due to some internal error.
    `InvalidDestinationException` - if an invalid topic is specified.

### unsubscribe

    public void unsubscribe(String name)
                     throws JMSException

  Unsubscribes a durable subscription that has been created by a client.

  This method deletes the state being maintained on behalf of the subscriber by its provider.

  It is erroneous for a client to delete a durable subscription while there is an active `MessageConsumer` or `TopicSubscriber` for the subscription, or while a consumed message is part of a pending transaction or has not been acknowledged in the session.

  Specified by:
    `unsubscribe` in interface `Session`
  Parameters:
    `name` - the name used to identify this subscription
  Throws:
    `JMSException` - if the session fails to unsubscribe to the durable subscription due to some internal error.
    `InvalidDestinationException` - if an invalid subscription name is specified.
  Since:
    1.1

### isTarget

    public boolean isTarget(ActiveMQMessage message)

  Tests to see if the Message Dispatcher is a target for this message

  Specified by:
    `isTarget` in interface `ActiveMQMessageDispatcher`
  Parameters:
    `message` - the message to test
  Returns:
    true if the Message Dispatcher can dispatch the message

### dispatch

    public void dispatch(ActiveMQMessage message)

  Dispatch an ActiveMQMessage

  Specified by:
    `dispatch` in interface `ActiveMQMessageDispatcher`
  Parameters:
    `message` -

### acknowledge

    public void acknowledge()
                     throws JMSException

  Acknowledges all consumed messages of the session of this consumed message.

  All consumed JMS messages support the `acknowledge` method for use when a client has specified that its JMS session's consumed messages are to be explicitly acknowledged. By invoking `acknowledge` on a consumed message, a client acknowledges all messages consumed by the session that the message was delivered to.

  Calls to `acknowledge` are ignored for both transacted sessions and sessions specified to use implicit acknowledgement modes.

  A client may individually acknowledge each message as it is consumed, or it may choose to acknowledge messages as an application-defined group (which is done by calling acknowledge on the last received message of the group, thereby acknowledging all messages consumed by the session.)

  Messages that have been received but not acknowledged may be redelivered.

  Specified by:
    `acknowledge` in interface `MessageAcknowledge`
  Throws:
    `JMSException` - if the JMS provider fails to acknowledge the messages due to some internal error.
    `IllegalStateException` - if this method is called on a closed session.
  See Also:
    `Session.CLIENT_ACKNOWLEDGE`

### doAcknowledge

    protected void doAcknowledge(boolean isClosing)
                          throws JMSException

  Throws:
    `JMSException`

### messageDelivered

    protected void messageDelivered(boolean sendAcknowledge,
                                    ActiveMQMessage message,
                                    boolean messageConsumed)

### addConsumer

    protected void addConsumer(ActiveMQMessageConsumer consumer)
                        throws JMSException

  Parameters:
    `consumer` -
  Throws:
    `JMSException`

### removeConsumer

    protected void removeConsumer(ActiveMQMessageConsumer consumer)
                           throws JMSException

  Parameters:
    `consumer` -
  Throws:
    `JMSException`

### createConsumerInfo

    protected ConsumerInfo createConsumerInfo(ActiveMQMessageConsumer consumer)
                                       throws JMSException

  Throws:
    `JMSException`

### addProducer

    protected void addProducer(ActiveMQMessageProducer producer)
                        throws JMSException

  Parameters:
    `producer` -
  Throws:
    `JMSException`

### removeProducer

    protected void removeProducer(ActiveMQMessageProducer producer)
                           throws JMSException

  Parameters:
    `producer` -
  Throws:
    `JMSException`

### createProducerInfo

    protected ProducerInfo createProducerInfo(ActiveMQMessageProducer producer)
                                       throws JMSException

  Throws:
    `JMSException`

### start

    protected void start()

  Start this Session

### stop

    protected void stop()

  Stop this Session

### getSessionId

    protected String getSessionId()

  Returns:
    Returns the sessionId.

### setSessionId

    protected void setSessionId(String sessionId)

  Parameters:
    `sessionId` - The sessionId to set.

### getStartTime

    protected long getStartTime()

  Returns:
    Returns the startTime.

### setStartTime

    protected void setStartTime(long startTime)

  Parameters:
    `startTime` - The startTime to set.

### send

    protected void send(ActiveMQMessageProducer producer,
                        Destination destination,
                        Message message,
                        int deliveryMode,
                        int priority,
                        long timeToLive,
                        boolean reuseMessageId)
                 throws JMSException

  send the message for dispatch by the broker

  Parameters:
    `producer` -
    `destination` -
    `message` -
    `deliveryMode` -
    `priority` -
    `timeToLive` -
  Throws:
    `JMSException`

### doStartTransaction

    protected void doStartTransaction()
                               throws JMSException

  Send TransactionInfo to indicate transaction has started

  Throws:
    `JMSException` - if some internal error occurs

### getLocalTransactionEventListener

    public LocalTransactionEventListener getLocalTransactionEventListener()

  Returns:
    Returns the localTransactionEventListener.

### setLocalTransactionEventListener

    public void setLocalTransactionEventListener(LocalTransactionEventListener localTransactionEventListener)

  Used by the resource adapter to listen to transaction events.

  Parameters:
    `localTransactionEventListener` - The localTransactionEventListener to set.

### isXaTransacted

    protected boolean isXaTransacted()

### getNextTransactionId

    protected String getNextTransactionId()

### setSessionConsumerDispatchState

    protected void setSessionConsumerDispatchState(int value)
                                            throws JMSException

  Throws:
    `JMSException`

### redeliverUnacknowledgedMessages

    protected void redeliverUnacknowledgedMessages()

### redeliverUnacknowledgedMessages

    protected void redeliverUnacknowledgedMessages(boolean onlyDeliverTransientConsumed)

### clearMessagesInProgress

    protected void clearMessagesInProgress()

### isTransacted

    protected boolean isTransacted()

### isClientAcknowledge

    protected boolean isClientAcknowledge()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 Protique, Ltd.. All Rights Reserved.